package com.logicbig.example;

import org.springframework.context.support.DefaultMessageSourceResolvable;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

import java.math.BigDecimal;

public class ValidatorForInstanceOfExample {

    public static void main(String[] args) {
        Validator validator = Validator.forInstanceOf(Number.class, (number, errors) -> {
            if (number.doubleValue() < 0) {
                errors.reject("number.negative", String.format("Number (%s) cannot be negative. Found: %s",
                        number.getClass(), number));
            }
        });

        if (validator.supports(Integer.class)) {
            Errors errors = validator.validateObject(Integer.valueOf(-1));
            errors.getAllErrors().stream()
                    .map(DefaultMessageSourceResolvable::getDefaultMessage)
                    .forEach(System.out::println);
        }
        if (validator.supports(BigDecimal.class)) {
            Errors errors = validator.validateObject(BigDecimal.valueOf(-10));
            errors.getAllErrors().stream()
                    .map(DefaultMessageSourceResolvable::getDefaultMessage)
                    .forEach(System.out::println);
        }
    }
}